//---------------------------------------------------------------------------
#ifndef AddThreadRangeH
#define AddThreadRangeH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "StitchStructures.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TAddThreadRangeForm : public TForm
{
__published:	// IDE-managed Components
    TLabel *Label1;
    TLabel *Label2;
    TImage *Image2;
    TBevel *Bevel1;
    TLabel *Label3;
    TImage *Image3;
    TLabel *Label4;
    TPanel *Panel1;
    TLabel *Label5;
    TLabel *Label6;
    TLabel *Label7;
    TLabel *Label8;
    TStatusBar *StatusBar1;
    TEdit *Edit1;
    TLabel *Label9;
    TEdit *Edit2;
    TEdit *Edit3;
    TLabel *Label10;
    TLabel *Label11;
    TButton *CalculateButton;
    TBevel *Bevel2;
    TButton *OKButton;
    TButton *CancelButton;
    TButton *HelpButton;
    TEdit *ShortThreadName;
    TLabel *Label12;
    TLabel *Label13;
    TEdit *ThreadName;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall CalculateButtonClick(TObject *Sender);
    void __fastcall HelpButtonClick(TObject *Sender);
    void __fastcall OKButtonClick(TObject *Sender);
    void __fastcall Image2MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall Image3MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall Edit1Change(TObject *Sender);
    void __fastcall Edit2Change(TObject *Sender);
private:	// User declarations
    DynamicArray <DMCColourData> DMCColourList;
    DynamicArray <TweedColourData> TweedList;
    void __fastcall ReadDMCColours(void);
    void __fastcall DisplayHint(TObject *Sender);
    void __fastcall FillImage2(void);
    void __fastcall FillImage3(void);
    void __fastcall Calculate(void);
    bool shorttitlefound;
public:		// User declarations
    __fastcall TAddThreadRangeForm(TComponent* Owner);
    AnsiString FileName;
    void __fastcall Initialise(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TAddThreadRangeForm *AddThreadRangeForm;
//---------------------------------------------------------------------------
#endif
