//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
USERES("BlendThreads.res");
USEFORM("StitchForm.cpp", PlanForm);
USEUNIT("..\..\Common Files\StringHelp.cpp");
USERC("..\..\Common Files\StringResource.rc");
USEFORM("About.cpp", AboutBox);
USEFORM("Backstitchedit.cpp", BackStitchForm);
USERES("TargetCursor.res");
USEUNIT("StitchStructures.cpp");
USERES("DropperCursor.res");
USEFORM("Transparency.cpp", TransparencyForm);
USEUNIT("..\..\Common Files\GraphicsHelp.cpp");
USEFORM("RestoreStitches.cpp", RestoreStitchesForm);
USERES("..\..\Common Files\DrawCursor.res");
USEFORM("DefinePrintout.cpp", DefinePrintoutForm);
USEFORM("ThreadConversion.cpp", ThreadConversionForm);
USEUNIT("..\..\Common Files\MathsHelp.cpp");
USEFORM("ThreadMerge.cpp", ThreadMergeForm);
USERES("..\..\Common Files\GrabCursor1.res");
USEFORM("CropChartImage.cpp", CropChartImageForm);
USEFORM("PrintPreview.cpp", PrintPreviewForm);
USEUNIT("..\..\Common Files\GIFImage.pas");
USEFORM("DMCList.cpp", DMCListForm);
USEFORM("BlendList.cpp", BlendListForm);
USEFORM("PaletteList.cpp", PaletteListForm);
USEFORM("ImageDetails.cpp", ImageDetailsForm);
USEFORM("NewImage.cpp", NewImageForm);
USEFORM("ImageEditor.cpp", ImageEditorForm);
USERES("..\..\Common Files\FillCursor.res");
USERES("..\..\Common Files\TextCursor.res");
USERES("..\..\Common Files\LineCursor.res");
USERES("..\..\Common Files\DrawRectangle.res");
USERES("..\..\Common Files\DrawCircle.res");
USERES("..\..\Common Files\DrawBlock.res");
USEFORM("EnterColour.cpp", EnterColourForm);
USERES("..\..\Common Files\DrawFreeForm.res");
USEFORM("BackStitchList.cpp", BackStitchListForm);
USEFORM("SetSymbols.cpp", SetSymbolsForm);
USEFORM("SetDefaultSymbols.cpp", SetDefaultSymbolsForm);
USEFORM("DefaultSettings.cpp", DefaultSettingsForm);
USEFORM("AddThreadRange.cpp", AddThreadRangeForm);
USEFORM("DeleteThreadRange.cpp", DeleteThreadRangeForm);
USEFORM("CustomDither.cpp", CustomDitherForm);
USEFORM("ObtainRGB.cpp", ObtainRGBForm);
USEFORM("ColourEntry.cpp", ColourEntryForm);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    try
    {
         Application->Initialize();
         Application->Title = "'Chestnut Pens' Cross Stitch Chart Creator with Thread Blending";
         Application->CreateForm(__classid(TPlanForm), &PlanForm);
         Application->CreateForm(__classid(TBackStitchForm), &BackStitchForm);
         Application->CreateForm(__classid(TTransparencyForm), &TransparencyForm);
         Application->CreateForm(__classid(TDMCListForm), &DMCListForm);
         Application->CreateForm(__classid(TBlendListForm), &BlendListForm);
         Application->CreateForm(__classid(TPaletteListForm), &PaletteListForm);
         Application->CreateForm(__classid(TBackStitchListForm), &BackStitchListForm);
         Application->Run();
    }
    catch (Exception &exception)
    {
         Application->ShowException(&exception);
    }
    return 0;
}
//---------------------------------------------------------------------------
