//---------------------------------------------------------------------------
#ifndef DefinePrintoutH
#define DefinePrintoutH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "StitchStructures.h"
//---------------------------------------------------------------------------
class TDefinePrintoutForm : public TForm
{
__published:	// IDE-managed Components
    TCheckBox *FrontSheet;
    TEdit *Title;
    TLabel *Label1;
    TComboBox *TitleFont;
    TLabel *Label2;
    TComboBox *TitleSize;
    TLabel *Label3;
    TLabel *Label4;
    TEdit *ImageCopyright;
    TComboBox *ImageCopyrightFont;
    TComboBox *ImageCopyrightSize;
    TLabel *Label5;
    TEdit *ChartCopyright;
    TComboBox *ChartCopyrightFont;
    TComboBox *ChartCopyrightSize;
    TCheckBox *IndexPage;
    TCheckBox *ColourChart;
    TCheckBox *MonochromeChart;
    TCheckBox *DetailedKey;
    TCheckBox *FabricDetails;
    TCheckBox *StitchesPerPage;
    TButton *OKButton;
    TButton *CancelButton;
    TCheckBox *BackStitches;
    TCheckBox *ChartPageXRef;
    TLabel *Label6;
    TComboBox *PageNumber;
    TLabel *Label7;
    TComboBox *ChartFont;
    TLabel *Label8;
    TComboBox *ChartFontSize;
    TLabel *Label9;
    TButton *PrintPreviewButton;
    TLabel *Label10;
    TButton *AcceptButton;
    void __fastcall FrontSheetClick(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall IndexPageClick(TObject *Sender);
    void __fastcall PrintPreviewButtonClick(TObject *Sender);
    void __fastcall AcceptButtonClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    void __fastcall Initialise(void);
    printout __fastcall RetrieveData(void);
    printout ChartPrintout;
    bool Accept;
    __fastcall TDefinePrintoutForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TDefinePrintoutForm *DefinePrintoutForm;
//---------------------------------------------------------------------------
#endif
