//---------------------------------------------------------------------------
#ifndef ImageEditorH
#define ImageEditorH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "StitchStructures.h"
#include <Buttons.hpp>
#include <ImgList.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TImageEditorForm : public TForm
{
__published:	// IDE-managed Components
    TStatusBar *StatusBar1;
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Cancel1;
    TMenuItem *N1;
    TMenuItem *Exit1;
    TPanel *Panel3;
    TPanel *Panel4;
    TImage *LeftRuler;
    TImage *TopRuler;
    TImage *Image1;
    TScrollBar *HorizontalScrollBar;
    TScrollBar *VerticalScrollBar;
    TTimer *Timer1;
    TImageList *ImageList1;
    TMenuItem *Edit1;
    TMenuItem *Cut1;
    TMenuItem *Copy1;
    TMenuItem *Move1;
    TMenuItem *N2;
    TMenuItem *SelectAll1;
    TMenuItem *Select2;
    TMenuItem *BlendColours1;
    TMenuItem *N4;
    TMenuItem *CopyDMCPalette1;
    TMenuItem *CopyBlendPalette1;
    TMenuItem *View1;
    TMenuItem *DrawingTools1;
    TMenuItem *Pencil1;
    TMenuItem *Line1;
    TMenuItem *LineWidth1;
    TMenuItem *Rectangle1;
    TMenuItem *Ellipse1;
    TMenuItem *N5;
    TMenuItem *N6;
    TMenuItem *Text1;
    TMenuItem *Zoom111;
    TMenuItem *ZoomIn1;
    TMenuItem *ZoomOut1;
    TMenuItem *N7;
    TMenuItem *EyeDropper1;
    TMenuItem *OneStitch1;
    TMenuItem *TwoStitches1;
    TMenuItem *FourStitches1;
    TMenuItem *N8;
    TMenuItem *Undo1;
    TFontDialog *FontDialog1;
    TMenuItem *FloodFill1;
    TMenuItem *N9;
    TMenuItem *Font1;
    TMenuItem *Undo2;
    TMenuItem *Select1;
    TMenuItem *Erase1;
    TMenuItem *Block1;
    TMenuItem *Settings1;
    TMenuItem *DeselectafterOperation1;
    TPopupMenu *PopupMenu1;
    TMenuItem *BringtoFront1;
    TMenuItem *SendtoBack1;
    TMenuItem *N10;
    TMenuItem *Cut2;
    TMenuItem *DeselectAll1;
    TMenuItem *N11;
    TMenuItem *Show1;
    TMenuItem *Hide1;
    TMenuItem *All1;
    TMenuItem *N12;
    TMenuItem *AllPoints1;
    TMenuItem *AllLines1;
    TMenuItem *AllFloodFills1;
    TMenuItem *AllTextObjects1;
    TMenuItem *AllRectangles1;
    TMenuItem *N13;
    TMenuItem *N14;
    TMenuItem *AllEllipsesCircles1;
    TMenuItem *N15;
    TMenuItem *AllEraseObjects1;
    TMenuItem *AllBlocks1;
    TMenuItem *All2;
    TMenuItem *N16;
    TMenuItem *AllPencilObjects1;
    TMenuItem *AllLines2;
    TMenuItem *AllFloodFills2;
    TMenuItem *N17;
    TMenuItem *AllText1;
    TMenuItem *N18;
    TMenuItem *AllRectangles2;
    TMenuItem *AllEllipsesCircles2;
    TMenuItem *N19;
    TMenuItem *AllEraseObjects2;
    TMenuItem *AllBlocks2;
    TMenuItem *N20;
    TMenuItem *SelectedItems1;
    TMenuItem *N21;
    TMenuItem *BringtoFront2;
    TMenuItem *SendtoBack2;
    TMenuItem *SelectTool1;
    TMenuItem *N22;
    TMenuItem *N23;
    TMenuItem *SelectAllPencilTools1;
    TMenuItem *SelectAllLines1;
    TMenuItem *SelectAllFloodFills1;
    TMenuItem *N24;
    TMenuItem *SelectAllTextObjects1;
    TMenuItem *N25;
    TMenuItem *SelectAllRectangles1;
    TMenuItem *SelectAllEllipsesCircles1;
    TMenuItem *N26;
    TMenuItem *SelectAllEraseObjects1;
    TMenuItem *SelectAllBlocks1;
    TMenuItem *Deselect1;
    TMenuItem *N3;
    TMenuItem *DeselectAllPencilObjects1;
    TMenuItem *DeselectAllLines1;
    TMenuItem *DeselectAllFloodFills1;
    TMenuItem *N27;
    TMenuItem *DeselectAllTextObjects1;
    TMenuItem *N28;
    TMenuItem *DeselectAllRectangles1;
    TMenuItem *DeselectAllEllipsesCircles1;
    TMenuItem *N29;
    TMenuItem *DeselectallEraseObjects1;
    TMenuItem *DeselectAllBlocks1;
    TMenuItem *ShowBackground1;
    TMenuItem *Copy2;
    TMenuItem *Move2;
    TMenuItem *ForwardOne1;
    TMenuItem *BackOne1;
    TMenuItem *BringForwardOne1;
    TMenuItem *BackOne2;
    TMenuItem *N30;
    TMenuItem *EditPencilObject1;
    TMenuItem *EditLine1;
    TMenuItem *EditFloodFill1;
    TMenuItem *EditText1;
    TMenuItem *EditRectangle1;
    TMenuItem *EditEllipseCircle1;
    TMenuItem *EditEraseItem1;
    TMenuItem *EditBlock1;
    TMenuItem *N31;
    TMenuItem *BreakLink1;
    TMenuItem *LinkBlocks1;
    TMenuItem *RegenerateFloodFill1;
    TMenuItem *ShowBackground2;
    TMenuItem *FloodFillFillDiagonalstoo1;
    TMenuItem *ShowLinksBetweenBlocks1;
    TMenuItem *ShowLinksBetweenBlocks2;
    TMenuItem *N32;
    TMenuItem *AntiAliasing1;
    TMenuItem *None1;
    TMenuItem *DMCColoursOnly1;
    TMenuItem *DMCandBlendedThreads1;
    TMenuItem *SetColourSpaceDivisions1;
    TMenuItem *SubspaceSampling1;
    TMenuItem *None2;
    TMenuItem *N2xMedium;
    TMenuItem *N4xHigh;
    TMenuItem *EditFloodFill;
    TMenuItem *RotateText1;
    TMenuItem *ChangeText1;
    TMenuItem *RegenerateAntiAliasing1;
    TMenuItem *PickTextColour1;
    TMenuItem *Help1;
    TMenuItem *Help2;
    TMenuItem *RegenerateAntiAliasing2;
    TMenuItem *PickLineColour1;
    TMenuItem *PickColour1;
    TMenuItem *PickCircleColour1;
    TMenuItem *PickPencilObjectColour1;
    TMenuItem *EditPencilObjectPoints1;
    TMenuItem *EditBlock2;
    TMenuItem *MoveStartPoint1;
    TMenuItem *MoveEndPoint1;
    TMenuItem *N33;
    TMenuItem *LinearArray1;
    TScrollBox *Panel1;
    TImage *Image2;
    TLabel *Label1;
    TShape *Foreground;
    TShape *Background;
    TLabel *Label2;
    TImage *Image3;
    TScrollBox *Panel2;
    TLabel *Label6;
    TBevel *Bevel3;
    TSpeedButton *PixelEditButton;
    TSpeedButton *LineButton;
    TSpeedButton *EyedropperButton;
    TSpeedButton *FloodFillButton;
    TLabel *Label4;
    TBevel *Bevel1;
    TSpeedButton *TextButton;
    TSpeedButton *FontButton;
    TLabel *Label3;
    TComboBox *FontHeightComboBox;
    TLabel *Label5;
    TBevel *Bevel2;
    TSpeedButton *RectangleButton;
    TSpeedButton *CircleButton;
    TSpeedButton *LineWidth1Button;
    TSpeedButton *LineWidth2Button;
    TSpeedButton *LineWidth4Button;
    TLabel *Label7;
    TSpeedButton *UndoButton;
    TSpeedButton *SelectButton;
    TBevel *Bevel4;
    TSpeedButton *EraseButton;
    TSpeedButton *BlockButton;
    TLabel *Label8;
    TBevel *Bevel5;
    TSpeedButton *ZoomInButton;
    TSpeedButton *ZoomOutButton;
    TSpeedButton *Zoom1to1Button;
    TMemo *Memo1;
    TMenuItem *Rotate1;
    TMenuItem *Rotate2;
    TMenuItem *Mirror1;
    TMenuItem *Mirror2;
    TMenuItem *RegenerateSelectedRectangles1;
    TMenuItem *RegenerateSelectedEllipsesCircles1;
    TMenuItem *LineWidth11;
    TMenuItem *LineWidth21;
    TMenuItem *LineWidth41;
    TMenuItem *LineWidth12;
    TMenuItem *LineWidth22;
    TMenuItem *LineWidth42;
    TMenuItem *LineWidth13;
    TMenuItem *LineWidth23;
    TMenuItem *LineWidth43;
    TMenuItem *N34;
    TMenuItem *N35;
    TMenuItem *N36;
    TMenuItem *ChangeSize1;
    TMenuItem *ChangeSize2;
    TMenuItem *N37;
    TMenuItem *RotateBlock90;
    TMenuItem *RotateBlock180;
    TMenuItem *RotateBlock270;
    TMenuItem *N38;
    TMenuItem *MirrorVertical;
    TMenuItem *MirrorHorizontal;
    TMenuItem *MirrorVertical2;
    TMenuItem *MirrorHorizontal2;
    TMenuItem *CopyChartImage1;
    TSpeedButton *FillShapeButton;
    TMenuItem *FillShapes1;
    TMenuItem *N39;
    TMenuItem *Filled1;
    TMenuItem *NotFilled1;
    TMenuItem *N40;
    TMenuItem *Filled2;
    TMenuItem *NotFilled2;
    TSpeedButton *PolyLineButton;
    TMenuItem *EditPolyLine1;
    TMenuItem *PolylineTool1;
    TMenuItem *PickLineColour2;
    TMenuItem *RegenerateAntialiasing3;
    TMenuItem *MovePoints1;
    TMenuItem *N41;
    TMenuItem *LineWidth14;
    TMenuItem *LineWidth24;
    TMenuItem *LineWidth44;
    TMenuItem *AllPolylines1;
    TMenuItem *AllPolylines2;
    TMenuItem *N42;
    TMenuItem *PasteAsBackgroundImage1;
    TMenuItem *PasteAsBlock1;
    TMenuItem *ChangeFont1;
    TMenuItem *FillShape1;
    TSpeedButton *FreeFormButton;
    TMenuItem *FreeForm1;
    TMenuItem *EditFreeFormShape1;
    TMenuItem *PickFreeFormShapeColour1;
    TMenuItem *RegenerateAntiAliasing4;
    TMenuItem *MovePoints2;
    TMenuItem *N43;
    TMenuItem *LineWidth15;
    TMenuItem *LineWidth25;
    TMenuItem *LineWidth45;
    TMenuItem *N44;
    TMenuItem *Filled3;
    TMenuItem *NotFilled3;
    TMenuItem *AllFreeFormShapes1;
    TMenuItem *AllFreeFormShapes2;
    TMenuItem *N45;
    TMenuItem *HideSelected1;
    TPopupMenu *PopupMenu2;
    TMenuItem *PointHelp;
    TMenuItem *EyeDropperHelp;
    TMenuItem *LineHelp;
    TMenuItem *PolyLineHelp;
    TMenuItem *FloodFillHelp;
    TMenuItem *TextHelp;
    TMenuItem *FontHelp;
    TMenuItem *TextHeightHelp;
    TMenuItem *RectangleHelp;
    TMenuItem *CircleHelp;
    TMenuItem *FreeFormHelp;
    TMenuItem *LineWidthHelp;
    TMenuItem *FilledHelp;
    TMenuItem *UndoHelp;
    TMenuItem *SelectHelp;
    TMenuItem *EraseHelp;
    TMenuItem *BlockHelp;
    TMenuItem *ZoomInHelp;
    TMenuItem *ZoomOutHelp;
    TMenuItem *Zoom1to1Help;
    TMenuItem *N46;
    TMenuItem *Select3;
    TMenuItem *All3;
    TMenuItem *N47;
    TMenuItem *AllPencilObjects2;
    TMenuItem *AllLines3;
    TMenuItem *AllPolylines3;
    TMenuItem *AllFloodFills3;
    TMenuItem *N48;
    TMenuItem *AllTextObjects2;
    TMenuItem *N49;
    TMenuItem *AllRectangles3;
    TMenuItem *AllEllipsesCircles3;
    TMenuItem *AllFreeFormShapes3;
    TMenuItem *N50;
    TMenuItem *AllEraseObjects3;
    TMenuItem *AllBlocks3;
    TMenuItem *N51;
    TMenuItem *InvertSelection1;
    TMenuItem *Deselect2;
    TMenuItem *All4;
    TMenuItem *N52;
    TMenuItem *AllPencilObjects3;
    TMenuItem *AllLines4;
    TMenuItem *AllPolylines4;
    TMenuItem *AllFloodFills4;
    TMenuItem *N53;
    TMenuItem *AllTextObjects3;
    TMenuItem *AllRectangles4;
    TMenuItem *AllEllipsesCircles4;
    TMenuItem *AllFreeFormShapes4;
    TMenuItem *N54;
    TMenuItem *AllEraseObjects4;
    TMenuItem *AllBlocks4;
    TMenuItem *N55;
    void __fastcall FormResize(TObject *Sender);
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall Image2MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall Image2MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall Image3MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall Image3MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall CopyPaletteImage2Click(TObject *Sender);
    void __fastcall CopyPaletteImage3Click(TObject *Sender);
    void __fastcall StatusBar1DrawPanel(TStatusBar *StatusBar,
          TStatusPanel *Panel, const TRect &Rect);
    void __fastcall View1Click(TObject *Sender);
    void __fastcall BlendColours1Click(TObject *Sender);
    void __fastcall ZoomIn1Click(TObject *Sender);
    void __fastcall ZoomOut1Click(TObject *Sender);
    void __fastcall VerticalScrollBarScroll(TObject *Sender,
          TScrollCode ScrollCode, int &ScrollPos);
    void __fastcall FormMouseWheelUp(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall FormMouseWheelDown(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall Zoom111Click(TObject *Sender);
    void __fastcall HorizontalScrollBarScroll(TObject *Sender,
          TScrollCode ScrollCode, int &ScrollPos);
    void __fastcall PixelEditButtonClick(TObject *Sender);
    void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall Image1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Edit1Click(TObject *Sender);
    void __fastcall UndoButtonMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
    void __fastcall Undo1Click(TObject *Sender);
    void __fastcall EyedropperButtonClick(TObject *Sender);
    void __fastcall FloodFillButtonClick(TObject *Sender);
    void __fastcall FontButtonClick(TObject *Sender);
    void __fastcall FontHeightComboBoxChange(TObject *Sender);
    void __fastcall TextButtonClick(TObject *Sender);
    void __fastcall LineButtonClick(TObject *Sender);
    void __fastcall Image1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall LineWidth1ButtonClick(TObject *Sender);
    void __fastcall EraseButtonClick(TObject *Sender);
    void __fastcall LineButtonMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall RectangleButtonClick(TObject *Sender);
    void __fastcall RectangleButtonMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
    void __fastcall CircleButtonMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
    void __fastcall CircleButtonClick(TObject *Sender);
    void __fastcall LineWidth1Click(TObject *Sender);
    void __fastcall DrawingTools1Click(TObject *Sender);
    void __fastcall Pencil1Click(TObject *Sender);
    void __fastcall Line1Click(TObject *Sender);
    void __fastcall FloodFill1Click(TObject *Sender);
    void __fastcall EyeDropper1Click(TObject *Sender);
    void __fastcall Text1Click(TObject *Sender);
    void __fastcall Rectangle1Click(TObject *Sender);
    void __fastcall Ellipse1Click(TObject *Sender);
    void __fastcall Erase1Click(TObject *Sender);
    void __fastcall SelectButtonClick(TObject *Sender);
    void __fastcall Select1Click(TObject *Sender);
    void __fastcall BlockButtonClick(TObject *Sender);
    void __fastcall Block1Click(TObject *Sender);
    void __fastcall Settings1Click(TObject *Sender);
    void __fastcall DeselectafterOperation1Click(TObject *Sender);
    void __fastcall PopupMenu1Popup(TObject *Sender);
    void __fastcall BringtoFront1Click(TObject *Sender);
    void __fastcall SendtoBack1Click(TObject *Sender);
    void __fastcall SelectAll1Click(TObject *Sender);
    void __fastcall DeselectAll1Click(TObject *Sender);
    void __fastcall All1Click(TObject *Sender);
    void __fastcall AllPoints1Click(TObject *Sender);
    void __fastcall All2Click(TObject *Sender);
    void __fastcall AllPencilObjects1Click(TObject *Sender);
    void __fastcall Show1Click(TObject *Sender);
    void __fastcall SelectedItems1Click(TObject *Sender);
    void __fastcall SelectAllPencilTools1Click(TObject *Sender);
    void __fastcall DeselectAllPencilObjects1Click(TObject *Sender);
    void __fastcall Hide1Click(TObject *Sender);
    void __fastcall ShowBackground1Click(TObject *Sender);
    void __fastcall Cut1Click(TObject *Sender);
    void __fastcall Copy1Click(TObject *Sender);
    void __fastcall Cancel1Click(TObject *Sender);
    void __fastcall Move1Click(TObject *Sender);
    void __fastcall ForwardOne1Click(TObject *Sender);
    void __fastcall BackOne1Click(TObject *Sender);
    void __fastcall RegenerateFloodFill1Click(TObject *Sender);
    void __fastcall FloodFillFillDiagonalstoo1Click(TObject *Sender);
    void __fastcall PickObjectColourClick(TObject *Sender);
    void __fastcall ShowLinksBetweenBlocks1Click(TObject *Sender);
    void __fastcall AntiAliasClick(TObject *Sender);
    void __fastcall AntiAliasing1Click(TObject *Sender);
    void __fastcall SelectTool1Click(TObject *Sender);
    void __fastcall Select2Click(TObject *Sender);
    void __fastcall Deselect1Click(TObject *Sender);
    void __fastcall RegenerateObject(TObject *Sender);
    void __fastcall ChangeText1Click(TObject *Sender);
    void __fastcall RotateText1Click(TObject *Sender);
    void __fastcall Help2Click(TObject *Sender);
    void __fastcall SamplingClick(TObject *Sender);
    void __fastcall SubspaceSampling1Click(TObject *Sender);
    void __fastcall SetColourSpaceDivisions1Click(TObject *Sender);
    void __fastcall EditText1Click(TObject *Sender);
    void __fastcall BreakLink1Click(TObject *Sender);
    void __fastcall LinkBlocks1Click(TObject *Sender);
    void __fastcall FormKeyPress(TObject *Sender, char &Key);
    void __fastcall EditPencilObjectPoints1Click(TObject *Sender);
    void __fastcall EditPencilObject1Click(TObject *Sender);
    void __fastcall EditBlock1Click(TObject *Sender);
    void __fastcall MoveStartPoint1Click(TObject *Sender);
    void __fastcall EditLine1Click(TObject *Sender);
    void __fastcall EditEraseItem1Click(TObject *Sender);
    void __fastcall LinearArray1Click(TObject *Sender);
    void __fastcall EditBlock2Click(TObject *Sender);
    void __fastcall Rotate1Click(TObject *Sender);
    void __fastcall Mirror1Click(TObject *Sender);
    void __fastcall ChangeLineLineWidth(TObject *Sender);
    void __fastcall ChangeRectangleLineWidth(TObject *Sender);
    void __fastcall ChangeCircleLineWidth(TObject *Sender);
    void __fastcall ForegroundMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall ChangeSize1Click(TObject *Sender);
    void __fastcall EditRectangle1Click(TObject *Sender);
    void __fastcall ChangeSize2Click(TObject *Sender);
    void __fastcall EditEllipseCircle1Click(TObject *Sender);
    void __fastcall RotateBlock90Click(TObject *Sender);
    void __fastcall MirrorVerticalClick(TObject *Sender);
    void __fastcall MirrorHorizontalClick(TObject *Sender);
    void __fastcall MirrorVertical2Click(TObject *Sender);
    void __fastcall MirrorHorizontal2Click(TObject *Sender);
    void __fastcall CopyChartImage1Click(TObject *Sender);
    void __fastcall FillShapeButtonClick(TObject *Sender);
    void __fastcall Filled1Click(TObject *Sender);
    void __fastcall Filled2Click(TObject *Sender);
    void __fastcall PolylineTool1Click(TObject *Sender);
    void __fastcall PolyLineButtonClick(TObject *Sender);
    void __fastcall Image1DblClick(TObject *Sender);
    void __fastcall ChangePolyLineLineWidth(TObject *Sender);
    void __fastcall EditPolyLine1Click(TObject *Sender);
    void __fastcall MovePolyLinePoints(TObject *Sender);
    void __fastcall PasteAsBackgroundImage1Click(TObject *Sender);
    void __fastcall PasteAsBlock1Click(TObject *Sender);
    void __fastcall ChangeFont1Click(TObject *Sender);
    void __fastcall FreeFormButtonClick(TObject *Sender);
    void __fastcall EditFreeFormShape1Click(TObject *Sender);
    void __fastcall ChangeFreeFormLineWidthClick(TObject *Sender);
    void __fastcall MoveFreeFormPoints(TObject *Sender);
    void __fastcall FreeForm1Click(TObject *Sender);
    void __fastcall Filled3Click(TObject *Sender);
    void __fastcall PopupMenu2Popup(TObject *Sender);
    void __fastcall PointHelpClick(TObject *Sender);
    void __fastcall All3Click(TObject *Sender);
    void __fastcall AllPencilObjects2Click(TObject *Sender);
    void __fastcall Select3Click(TObject *Sender);
    void __fastcall InvertSelection1Click(TObject *Sender);
    void __fastcall Deselect2Click(TObject *Sender);
    void __fastcall All4Click(TObject *Sender);
    void __fastcall AllPencilObjects3Click(TObject *Sender);
private:	// User declarations
    TColor BackgroundColour;
    TColor ForegroundColour;
    void __fastcall DisplayCurrentColours(void);
    void __fastcall DisplayHint(TObject *Sender);
    void __fastcall DrawRulers(void);
    void __fastcall DrawPicture(void);
    void __fastcall DrawBitmap(void);
    void __fastcall DrawTransparentBackground(void);
    void __fastcall DrawVectors(TCanvas *Canvas);
    void __fastcall DrawVectors(TCanvas *Canvas, int Limit);
    void __fastcall DrawPoints(int ItemNumber, TCanvas *Canvas);
    void __fastcall DrawFloodFill(int ItemNumber, TCanvas *Canvas);
    void __fastcall DrawText(int ItemNumber, TCanvas *Canvas);
    void __fastcall DrawLine(int ItemNumber, TCanvas *Canvas);
    void __fastcall DrawPolyLine(int ItemNumber, TCanvas *Canvas);
    void __fastcall DrawErase(int ItemNumber, TCanvas *Canvas);
    void __fastcall DrawRectangle(int ItemNumber, TCanvas *Canvas);
    void __fastcall DrawCircle(int ItemNumber, TCanvas *Canvas);
    void __fastcall DrawFreeForm(int ItemNumber, TCanvas *Canvas);
    void __fastcall DrawBlock(int ItemNumber, TCanvas *Canvas);
    void __fastcall DrawOriginalBlock(int ItemNumber, TCanvas *Canvas);
    void __fastcall DrawSelectedItems(void);
    void __fastcall DrawLinksBetweenBlocks(void);
    void __fastcall SetPictureXStitchCount(int StitchCount);
    void __fastcall SetScrollBars(void);
    Graphics::TBitmap *TransparentColour;
    int fPictureXStitchCount;
    int SquareSize;
    bool active;
    TPoint TopLeft;
    //panel draw
    int ArrayPointer;
    bool UseDMCArray;
    bool preparetoblendforeground;
    bool preparetoblendbackground;
    TCursor crTargetCursor;
    TCursor crDropperCursor;
    TCursor crFloodFill;
    TCursor crDrawCursor;
    TCursor crTextCursor;
    TCursor crLineCursor;
    TCursor crDrawRectangle;
    TCursor crDrawCircle;
    TCursor crDrawBlock;
    TCursor crDrawFreeForm;
    //undo
    //TList *UndoList;
    TStringList *UndoTitleList;
    bool preparetosaveundo;
    bool Undoing;
    bool SingleUndo;
    void __fastcall AddUndoTitle(AnsiString Title);
    void __fastcall AddUndo(AnsiString Text);
    void __fastcall AddUndoChangePoint(int ItemNumber);
    void __fastcall AddUndoChangePolyLine(int ItemNumber);
    void __fastcall AddUndoChangeText(int ItemNumber);
    void __fastcall AddUndoChangeRectangle(int ItemNumber);
    void __fastcall AddUndoChangeCircle(int ItemNumber);
    void __fastcall AddUndoChangeFreeForm(int ItemNumber);
    AnsiString __fastcall LastUndoTitle(void);
    //editing
    TActionType ActionType;
    int DisplayItemNumber;
    textitem DefaultText;
    int LineWidth;
    TPoint LinearArray;
    DynamicArray <displaylist> DisplayList;
    DynamicArray <xref> XRefs;
    DynamicArray <pointitem> PointList;
    DynamicArray <floodfillitem> FloodFillList;
    DynamicArray <textitem> TextList;
    DynamicArray <lineitem> LineList;
    DynamicArray <freeformshapeitem> PolyLineList;
    DynamicArray <eraseitem> EraseList;
    DynamicArray <stdshapeitem> RectangleList;
    DynamicArray <stdshapeitem> CircleList;
    DynamicArray <freeformshapeitem> FreeFormList;
    DynamicArray <blockitem> BlockList;
    void __fastcall CreateXRefs(void);
    void __fastcall FillPointsLine(int arraypointer,int ItemNumber);
    void __fastcall FillPointsPolyLine(int arraypointer,int ItemNumber);
    void __fastcall FillPointsText(int arraypointer,int ItemNumber);
    void __fastcall FillPointsRectangle(int arraypointer,int ItemNumber);
    void __fastcall FillPointsCircle(int arraypointer,int ItemNumber);
    void __fastcall FillPointsFreeForm(int arraypointer,int ItemNumber);
    void __fastcall FillPointsBlock(int arraypointer,int ItemNumber);
    void __fastcall DisplayListAreaUpdate(int ItemNumber);
    void __fastcall DeleteDisplayItem(int ItemNumber, TDisplayType DisplayType);
    void __fastcall DeletePoints(int ItemNumber);
    void __fastcall DeleteFloodFill(int ItemNumber);
    void __fastcall DeleteText(int ItemNumber);
    void __fastcall DeleteLine(int ItemNumber);
    void __fastcall DeletePolyLine(int ItemNumber);
    void __fastcall DeleteErase(int ItemNumber);
    void __fastcall DeleteRectangle(int ItemNumber);
    void __fastcall DeleteCircle(int ItemNumber);
    void __fastcall DeleteFreeForm(int ItemNumber);
    void __fastcall DeleteBlock(int ItemNumber);
    void __fastcall TerminateCurrentAction(void);
    void __fastcall CompleteCurrentAction(void);
    displaylist __fastcall CopyPoint(TPoint delta, int ItemNumber);
    displaylist __fastcall CopyLine(TPoint delta, int ItemNumber);
    displaylist __fastcall CopyPolyLine(TPoint delta, int ItemNumber);
    displaylist __fastcall CopyFloodFill(TPoint delta, int ItemNumber);
    displaylist __fastcall CopyText(TPoint delta, int ItemNumber);
    displaylist __fastcall CopyRectangle(TPoint delta, int ItemNumber);
    displaylist __fastcall CopyCircle(TPoint delta, int ItemNumber);
    displaylist __fastcall CopyFreeForm(TPoint delta, int ItemNumber);
    displaylist __fastcall CopyErase(TPoint delta, int ItemNumber);
    displaylist __fastcall CopyBlock(TPoint delta, int ItemNumber);
    void __fastcall MovePoint(TPoint delta, int ItemNumber);
    void __fastcall MoveLine(TPoint delta, int ItemNumber);
    void __fastcall MovePolyLine(TPoint delta, int ItemNumber);
    void __fastcall MoveFloodFill(TPoint delta, int ItemNumber);
    void __fastcall MoveText(TPoint delta, int ItemNumber);
    void __fastcall MoveRectangle(TPoint delta, int ItemNumber);
    void __fastcall MoveCircle(TPoint delta, int ItemNumber);
    void __fastcall MoveFreeForm(TPoint delta, int ItemNumber);
    void __fastcall MoveErase(TPoint delta, int ItemNumber);
    void __fastcall MoveBlock(TPoint delta, int ItemNumber);
    TPoint __fastcall RotateTPoint(TPoint Point, TPoint Centre, double Angle);
    void __fastcall RotatePoint(TPoint Centre, int ItemNumber, int Angle);
    void __fastcall RotateLine(TPoint Centre, int ItemNumber, int Angle);
    void __fastcall RotatePolyLine(TPoint Centre, int ItemNumber, int Angle);
    void __fastcall RotateFloodFill(TPoint Centre, int ItemNumber, int Angle);
    void __fastcall RotateText(TPoint Centre, int ItemNumber, int Angle);
    void __fastcall RotateRectangle(TPoint Centre, int ItemNumber, int Angle);
    void __fastcall RotateCircle(TPoint Centre, int ItemNumber, int Angle);
    void __fastcall RotateFreeForm(TPoint Centre, int ItemNumber, int Angle);
    void __fastcall RotateErase(TPoint Centre, int ItemNumber, int Angle);
    void __fastcall RotateBlock(TPoint Centre, int ItemNumber, int Angle);
    TRect __fastcall MirrorRectanglePoints(TRect Rect,TPoint Centre, TMirrorAxis Axis);
    TPoint __fastcall MirrorTPoint(TPoint Point,TPoint Centre, TMirrorAxis Axis);
    //void __fastcall MirrorPoint(TPoint Centre, int ItemNumber, TMirrorAxis Axis);
    void __fastcall MirrorCopyPoint(TPoint Centre, int ItemNumber, TMirrorAxis Axis);
    //void __fastcall MirrorLine(TPoint Centre, int ItemNumber, TMirrorAxis Axis);
    void __fastcall MirrorCopyLine(TPoint Centre, int ItemNumber, TMirrorAxis Axis);
    void __fastcall MirrorCopyPolyLine(TPoint Centre, int ItemNumber, TMirrorAxis Axis);
    //void __fastcall MirrorFloodFill(TPoint Centre, int ItemNumber, TMirrorAxis Axis);
    void __fastcall MirrorCopyFloodFill(TPoint Centre, int ItemNumber, TMirrorAxis Axis);
    void __fastcall MirrorCopyRectangle(TPoint Centre, int ItemNumber, TMirrorAxis Axis);
    void __fastcall MirrorCopyCircle(TPoint Centre, int ItemNumber, TMirrorAxis Axis);
    void __fastcall MirrorCopyFreeForm(TPoint Centre, int ItemNumber, TMirrorAxis Axis);
    void __fastcall MirrorCopyErase(TPoint Centre, int ItemNumber, TMirrorAxis Axis);
    void __fastcall MirrorCopyBlock(TPoint Centre, int ItemNumber, TMirrorAxis Axis);
    void __fastcall ChangeFloodFillColour(TColor Colour);
    void __fastcall ChangeFloodFillColour(int ItemNumber, TColor Colour);
    void __fastcall ChangePointColour(int ItemNumber, TColor Colour);
    void __fastcall ChangeLineColour(int ItemNumber, TColor Colour);
    void __fastcall ChangePolyLineColour(int ItemNumber, TColor Colour);
    void __fastcall ChangeTextColour(int ItemNumber, TColor Colour);
    void __fastcall ChangeRectangleColour(int ItemNumber, TColor PenColour, TColor BrushColour);
    void __fastcall ChangeCircleColour(int ItemNumber, TColor PenColour, TColor BrushColour);
    void __fastcall ChangeFreeFormColour(int ItemNumber, TColor PenColour, TColor BrushColour);
    void __fastcall ChangeText(int ItemNumber, AnsiString NewText);
    void __fastcall LinkBlock(int ItemNumber, bool Linked, int LinkedBlock);
    //TColor __fastcall FindNearestDMCColour(TColor Colour);
    //TColor __fastcall FindNearestBlendColour(TColor Colour);
    double __fastcall ExtractAngle(TPoint delta);
    //rubberbanding and last mouse position etc
    bool wipedout;
    bool dragging;
    TPoint StartPointChart;
    TPoint StartPointScreen;
    TPoint EndPointChart;
    TPoint EndPointScreen;
    TPoint OldMousePositionScreen;
    double OldAngle;
    DynamicArray <TPoint> LinePoints;
    int pointbeingdragged;
    //Location
    chartposition __fastcall FindMousePosition(int X, int Y);
    chartposition __fastcall FindImage1Position(int X, int Y);
    TRect __fastcall FindImage1Position(TRect Rectangle);
    int __fastcall FindTopmostDisplayItem(int X, int Y);
    bool __fastcall QueryDisplayPoint(int X, int Y, int ItemNumber);
    bool __fastcall QueryDisplayFloodFill(int X, int Y, int ItemNumber);
    bool __fastcall QueryDisplayText(int X, int Y, int ItemNumber);
    bool __fastcall QueryDisplayLine(int X, int Y, int ItemNumber);
    bool __fastcall QueryDisplayPolyLine(int X, int Y, int ItemNumber);
    bool __fastcall QueryDisplayErase(int X, int Y, int ItemNumber);
    bool __fastcall QueryDisplayRectangle(int X, int Y, int ItemNumber);
    bool __fastcall QueryDisplayCircle(int X, int Y, int ItemNumber);
    bool __fastcall QueryDisplayFreeForm(int X, int Y, int ItemNumber);
    bool __fastcall QueryDisplayBlock(int X, int Y, int ItemNumber);
    bool __fastcall CheckPointPixelsinArea(TRect Rectangle, int ItemNumber);
    bool __fastcall CheckLinePixelsinArea(TRect Rectangle, int ItemNumber);
    bool __fastcall CheckPolyLinePixelsinArea(TRect Rectangle, int ItemNumber);
    bool __fastcall CheckFloodFillPixelsinArea(TRect Rectangle, int ItemNumber);
    bool __fastcall CheckTextPixelsinArea(TRect Rectangle, int ItemNumber);
    bool __fastcall CheckRectanglePixelsinArea(TRect Rectangle, int ItemNumber);
    bool __fastcall CheckCirclePixelsinArea(TRect Rectangle, int ItemNumber);
    bool __fastcall CheckFreeFormPixelsinArea(TRect Rectangle, int ItemNumber);
    bool __fastcall CheckErasePixelsinArea(TRect Rectangle, int ItemNumber);
    bool __fastcall CheckBlockPixelsinArea(TRect Rectangle, int ItemNumber);
    //settings
    bool deselectafteroperation;
    bool showbackground;
    bool floodfilldiagonals;
    bool showlinksbetweenblocks;
    TAntiAlias AntiAlias;
    bool fblendthreads;
    int subspacesampling;
    void __fastcall SetBlendThreads(bool bvalue);
    void __fastcall ResetActionButtons(void);
    bool fFillShapes;
    void __fastcall SetFillShapes(bool bvalue);

    //debug methods
    void __fastcall DebugBlock(int arrayentry);

    //information
    bool __fastcall CheckifItemsSelected(void);
    bool __fastcall CheckIfAnyPoints(void);
    bool __fastcall CheckIfAnyLines(void);
    bool __fastcall CheckIfAnyPolyLines(void);
    bool __fastcall CheckIfAnyFloodFills(void);
    bool __fastcall CheckIfAnyTextItems(void);
    bool __fastcall CheckIfAnyRectangles(void);
    bool __fastcall CheckIfAnyCircles(void);
    bool __fastcall CheckIfAnyFreeForms(void);
    bool __fastcall CheckIfAnyEraseItems(void);
    bool __fastcall CheckIfAnyBlocks(void);
    bool __fastcall CheckifEntityExists(int ItemNumber);
    bool __fastcall CheckifDisplayItemExists(int ItemNumber);
    int __fastcall CheckNumberofPointsSelected(void);
    int __fastcall CheckNumberofLinesSelected(void);
    int __fastcall CheckNumberofPolyLinesSelected(void);
    int __fastcall CheckNumberofFloodFillsSelected(void);
    int __fastcall CheckNumberofTextItemsSelected(void);
    int __fastcall CheckNumberofRectanglesSelected(void);
    int __fastcall CheckNumberofCirclesSelected(void);
    int __fastcall CheckNumberofFreeFormsSelected(void);
    int __fastcall CheckNumberofEraseItemsSelected(void);
    int __fastcall CheckNumberofBlocksSelected(void);

    //Properties
    __property bool AnyItemsSelected = {read = CheckifItemsSelected};
    __property bool AnyPointsExist = {read = CheckIfAnyPoints};
    __property bool AnyLinesExist = {read = CheckIfAnyLines};
    __property bool AnyPolyLinesExist = {read = CheckIfAnyPolyLines};
    __property bool AnyFloodFillsExist = {read = CheckIfAnyFloodFills};
    __property bool AnyTextItemsExist = {read = CheckIfAnyTextItems};
    __property bool AnyRectanglesExist = {read = CheckIfAnyRectangles};
    __property bool AnyCirclesExist = {read = CheckIfAnyCircles};
    __property bool AnyFreeFormsExist = {read = CheckIfAnyFreeForms};
    __property bool AnyEraseItemsExist = {read = CheckIfAnyEraseItems};
    __property bool AnyBlocksExist = {read = CheckIfAnyBlocks};
    __property int NumberPointsSelected = {read = CheckNumberofPointsSelected};
    __property int NumberLinesSelected = {read = CheckNumberofLinesSelected};
    __property int NumberPolyLinesSelected = {read = CheckNumberofPolyLinesSelected};
    __property int NumberFloodFillsSelected = {read = CheckNumberofFloodFillsSelected};
    __property int NumberTextItemsSelected = {read = CheckNumberofTextItemsSelected};
    __property int NumberRectanglesSelected = {read = CheckNumberofRectanglesSelected};
    __property int NumberCirclesSelected = {read = CheckNumberofCirclesSelected};
    __property int NumberFreeFormsSelected = {read = CheckNumberofFreeFormsSelected};
    __property int NumberEraseItemsSelected = {read = CheckNumberofEraseItemsSelected};
    __property int NumberBlocksSelected = {read = CheckNumberofBlocksSelected};
    __property bool FillShapes = {read = fFillShapes, write = SetFillShapes};

public:		// User declarations
    void __fastcall Initialise(void);
    void __fastcall Complete(void);
    DynamicArray <DMCColourData> DMCColourList;
    DynamicArray <DMCColourData> TweedList;
    AnsiString ShortThreadName;
    Graphics::TBitmap *Picture;
    int Zoom1;
    bool imagechanged;
    __property bool blendthreads = {read = fblendthreads, write = SetBlendThreads};
    int colourspacedivisions;
    threadconvsettings Conversion;
    __property int PictureXStitchCount = {read = fPictureXStitchCount, write = SetPictureXStitchCount};
    TColor __fastcall FindNearestDMCColour(TColor Colour);
    TColor __fastcall FindNearestBlendColour(TColor Colour);

    __fastcall TImageEditorForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TImageEditorForm *ImageEditorForm;
//---------------------------------------------------------------------------
#endif
