//---------------------------------------------------------------------------
#ifndef SetDefaultSymbolsH
#define SetDefaultSymbolsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include "StitchStructures.h"
//---------------------------------------------------------------------------
class TSetDefaultSymbolsForm : public TForm
{
__published:	// IDE-managed Components
    TButton *OKButton;
    TButton *CancelButton;
    TListBox *ListBox1;
    TListBox *ListBox2;
    TLabel *Label1;
    TLabel *Label2;
    TSpeedButton *UndoButton;
    TButton *ResetButton;
    TButton *HelpButton;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall ListBox1DrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
    void __fastcall ListBox1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall UndoButtonClick(TObject *Sender);
    void __fastcall ResetButtonClick(TObject *Sender);
    void __fastcall HelpButtonClick(TObject *Sender);
private:	// User declarations
    TCursor SymbolCursor;
    HICON SymbolIcon;
    bool dragging;
    int dragindex;
    DynamicArray <undolist> UndoList;
public:		// User declarations
    __fastcall TSetDefaultSymbolsForm(TComponent* Owner);
    DynamicArray <int> Symbols;
    void __fastcall Initialise(void);

};
//---------------------------------------------------------------------------
extern PACKAGE TSetDefaultSymbolsForm *SetDefaultSymbolsForm;
//---------------------------------------------------------------------------
#endif
