//---------------------------------------------------------------------------
#ifndef DefaultSettingsH
#define DefaultSettingsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TDefaultSettingsForm : public TForm
{
__published:	// IDE-managed Components
    TComboBox *ThreadSortMethod;
    TLabel *Label1;
    TLabel *Label2;
    TComboBox *StitchCount;
    TLabel *Label3;
    TComboBox *PlanCount;
    TCheckBox *ShowBackground;
    TCheckBox *SimpleKey;
    TLabel *Label4;
    TBevel *Bevel1;
    TLabel *Label5;
    TCheckBox *FrontSheet;
    TLabel *Label6;
    TComboBox *TitleFont;
    TLabel *Label7;
    TComboBox *TitleSize;
    TLabel *Label8;
    TLabel *Label9;
    TComboBox *ImageFont;
    TComboBox *ImageFontSize;
    TComboBox *ChartCopyright;
    TComboBox *ChartCopyrightFontSize;
    TLabel *Label10;
    TCheckBox *ContentsPage;
    TCheckBox *XRefImage;
    TCheckBox *ColourChart;
    TCheckBox *MonochromeChart;
    TCheckBox *BackStitches;
    TLabel *Label11;
    TLabel *Label12;
    TLabel *Label13;
    TComboBox *ChartFont;
    TComboBox *ChartFontSize;
    TCheckBox *DetailedKey;
    TCheckBox *StitchInfo;
    TCheckBox *FabricDetails;
    TButton *OKButton;
    TButton *CancelButton;
    TButton *ResetButton;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall ContentsPageClick(TObject *Sender);
    void __fastcall ResetButtonClick(TObject *Sender);
    void __fastcall OKButtonClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    __fastcall TDefaultSettingsForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TDefaultSettingsForm *DefaultSettingsForm;
//---------------------------------------------------------------------------
#endif
