//---------------------------------------------------------------------------
#ifndef DeleteThreadRangeH
#define DeleteThreadRangeH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include "StitchStructures.h"
//---------------------------------------------------------------------------
class TDeleteThreadRangeForm : public TForm
{
__published:	// IDE-managed Components
    TMemo *Memo1;
    TListBox *ListBox1;
    TButton *OKButton;
    TSpeedButton *UndoButton;
    TButton *CancelButton;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall ListBox1DblClick(TObject *Sender);
    void __fastcall UndoButtonClick(TObject *Sender);
    void __fastcall OKButtonClick(TObject *Sender);
    void __fastcall ListBox1Click(TObject *Sender);
private:	// User declarations
    int CurrentRange;
    DynamicArray <threadfile> ThreadList;
    DynamicArray <threadfile> UndoList;
    void __fastcall DisplayThreadList(void);
public:		// User declarations
    __fastcall TDeleteThreadRangeForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TDeleteThreadRangeForm *DeleteThreadRangeForm;
//---------------------------------------------------------------------------
#endif
