//---------------------------------------------------------------------------
#ifndef ImageDetailsH
#define ImageDetailsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TImageDetailsForm : public TForm
{
__published:	// IDE-managed Components
    TPanel *Panel1;
    TButton *OKButton;
    TRichEdit *RichEdit1;
    TPopupMenu *PopupMenu1;
    TMenuItem *Undo1;
    TMenuItem *N1;
    TMenuItem *Cut1;
    TMenuItem *Copy1;
    TMenuItem *Paste1;
    TMenuItem *N2;
    TMenuItem *SelectAll1;
    TImageList *ImageList1;
    TMenuItem *N3;
    TMenuItem *SaveAs1;
    TMenuItem *N4;
    TMenuItem *Print1;
    TSaveDialog *SaveDialog;
    void __fastcall OKButtonClick(TObject *Sender);
    void __fastcall Undo1Click(TObject *Sender);
    void __fastcall Cut1Click(TObject *Sender);
    void __fastcall Copy1Click(TObject *Sender);
    void __fastcall Paste1Click(TObject *Sender);
    void __fastcall SelectAll1Click(TObject *Sender);
    void __fastcall PopupMenu1Popup(TObject *Sender);
    void __fastcall SaveAs1Click(TObject *Sender);
    void __fastcall Print1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
    __fastcall TImageDetailsForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TImageDetailsForm *ImageDetailsForm;
//---------------------------------------------------------------------------
#endif
