//---------------------------------------------------------------------------
#ifndef RestoreStitchesH
#define RestoreStitchesH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "StitchStructures.h"

typedef struct {
    BackStitchData Stitch;
    TColor Colour;
    bool DrawWhite;
    bool selected;
    } restorestitch;

//---------------------------------------------------------------------------
class TRestoreStitchesForm : public TForm
{
__published:	// IDE-managed Components
    TListBox *ListBox1;
    TButton *OKButton;
    TButton *CancelButton;
    TButton *InvertButton;
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall ListBox1DrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
    void __fastcall ListBox1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall InvertButtonClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    DynamicArray <restorestitch> Stitches;
    void __fastcall FillList(void);
    __fastcall TRestoreStitchesForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TRestoreStitchesForm *RestoreStitchesForm;
//---------------------------------------------------------------------------
#endif
